# KEKS -- Python KEKS implementation
# Copyright (C) 2024-2025 Anton Rudenko <rudenko.ad@phystech.edu>
#               2024-2025 Sergey Matveev <stargrave@stargrave.org>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation, version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this program.  If not, see <http://www.gnu.org/licenses/>.

from unittest import TestCase

from hypothesis import given

from keks import dumps
from keks import loads
from tests.strategies import junk_st


class TestBool(TestCase):
    def test_encode_true(self):
        encoded = dumps(True)
        self.assertEqual(encoded, b"\x03")

    def test_encode_false(self):
        encoded = dumps(False)
        self.assertEqual(encoded, b"\x02")

    @given(junk_st)
    def test_decode_true(self, junk):
        encoded = b"\x03" + junk
        decoded, tail = loads(encoded)
        self.assertIs(decoded, True)
        self.assertSequenceEqual(tail, junk)

    @given(junk_st)
    def test_decode_false(self, junk):
        encoded = b"\x02" + junk
        decoded, tail = loads(encoded)
        self.assertIs(decoded, False)
        self.assertSequenceEqual(tail, junk)
